<?php
/**
 * @package ElvantoTools
 * @author JagTech
 * @version 1.4
 */
/*
Plugin Name: ElvantoTools
Plugin URI: http://jagtech.biz
Description: Display rosters and song lists from Elvanto
Author: JagTech
Version: 1.4
Author URI: http://jagtech.biz
*/

/*  Copyright 2015  JagTech  (email : sales@jagtech.biz)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

include_once('settings.php');
include_once('widget.php');

function elvantotools_roster_shortcode ($atts, $content = null) {
	//define('WP_DEBUG', true);
	$options = get_option('elvantotools_options');
	$system_date_format = 'M j, Y'; //get_option('date_format', 'M j, Y');
	$default_columns = '';
	foreach (explode(',', ELVANTOTOOLS_ROSTER_FIELD_NAMES) as $field) {
		if (isset($options['roster_'.$field]) && $options['roster_'.$field] == 'on') {
			if ($default_columns != '') {
				$default_columns .= ',';
			}
			$default_columns .= $field;
		}
	}
	if ($default_columns == '') {
		$default_columns = ELVANTOTOOLS_ROSTER_DEFAULT_COLUMNS;
	}
		
	extract(shortcode_atts(Array(
		'key' => isset($options['elvanto_api_key']) ? $options['elvanto_api_key'] : false,
		'offset' => isset($options['offset']) ? $options['offset'] : 0,
		'weeks' => isset($options['elvanto_weeks']) ? $options['elvanto_weeks'] : 1,
		'services' => isset($options['elvanto_services']) ? $options['elvanto_services'] : 0,
		'service_types' => isset($options['roster_service_types']) ? $options['roster_service_types'] : false,
		'departments' => isset($options['roster_departments']) ? $options['roster_departments'] : false,
		'show_details' => isset($options['roster_show_details']) ? $options['roster_show_details'] : false,
		'sub_departments' => isset($options['roster_sub_departments']) ? $options['roster_sub_departments'] : false,
		'positions' => isset($options['roster_positions']) ? $options['roster_positions'] : false,
		'show_depts' => isset($options['roster_show_depts']) ? ($options['roster_show_depts'] == 'on') : false,
		'show_subs' => isset($options['roster_show_subs']) ? ($options['roster_show_subs'] == 'on') : false,
		'columns' => $default_columns,
		'dates' => isset($options['elvanto_date_format']) && $options['elvanto_date_format'] ? 
						$options['elvanto_date_format'] : $system_date_format,
		'zone' => (isset($options['elvanto_time_zone']) && $options['elvanto_time_zone']) ? 
						$options['elvanto_time_zone'] : (get_option('timezone_string', false) ? 
													 get_option('timezone_string') :  
													 date_default_timezone_get()),
		'fullscreen' => false,
		'sort' => 'default'
	), $atts));

	$display_columns = explode(',',$columns);
	$content = '['.implode('] [',$display_columns).']';
	$prefix = '<div class="elvantotools_roster '.($fullscreen ? 'elvantotools_fullscreen' : '').'"><div class="elvantotools_table_scroll"><table>';
	$suffix = '</table></div></div>';
	$top_left_content = '<span class="dashicons dashicons-editor-expand elvantotools_go_fullscreen '.($fullscreen ? 'elvantotools_fullscreen_on' : '').'"></span>';
	$header_prefix = '<thead class="elvantotools_header">';
	$header_suffix = '</thead>';
	$header_element_prefix = '<th class="elvantotools-header-service">';
	$header_element_suffix = '</th>';
	$header_content = '[service]';
	$body_prefix = '<tbody>';
	$body_suffix = '</tbody>';
	$label_prefix = '<td class="elvantotools_label"><strong>';
	$label_suffix = '</strong></td>';
	$label_content = '';
	if ($show_depts) $label_content .= $label_prefix . '[department]' . $label_suffix;
	if ($show_subs) $label_content .= $label_prefix . '[sub_department]' . $label_suffix;
	$label_content .= $label_prefix . '[position]' . $label_suffix;
	$header_label_content = str_replace('td','th',$label_content);
	$row_prefix = '<tr>';
	$row_suffix = '</tr>';
	$element_prefix = '<td class="[class]">';
	$element_suffix = '</td>';
	$name_prefix = '<span class="elvantotools_name" name="[id]">';
	$name_suffix = '</span>';
	$name_separator = '<br>';
	$empty_prefix = '<tr><td>';
	$empty_suffix = '</td></tr>';
	
	$output = elvantotools_roster_generate ($key, $offset, $weeks, $services, $service_types, $departments, $sub_departments, $positions, $display_columns, $dates, $zone, $sort, $prefix, $suffix, $top_left_content, $header_label_content, $header_content, $header_prefix, $header_suffix, $header_element_prefix, $header_element_suffix, $body_prefix, $body_suffix, $row_prefix, $row_suffix, $label_content, $element_prefix, $element_suffix, $name_prefix, $name_suffix, $name_separator, $content, $empty_prefix, $empty_suffix, $show_details);

	return do_shortcode($output);
//	return do_shortcode($output . "Sortorder=" . $rss->get_sortorder() . ",Maxterm=$max");
}

function elvantotools_songs_shortcode ($atts, $content = null) {
	//define('WP_DEBUG', true);
	$options = get_option('elvantotools_options');
	$system_date_format = 'M j, Y'; //get_option('date_format', 'M j, Y');
	$default_columns = '';
	foreach (explode(',', ELVANTOTOOLS_SONG_FIELD_NAMES) as $field) {
		if (isset($options['songs_'.$field]) && $options['songs_'.$field] == 'on') {
			if ($default_columns != '') {
				$default_columns .= ',';
			}
			$default_columns .= $field;
		}
	}
	if ($default_columns == '') {
		$default_columns = ELVANTOTOOLS_SONGS_DEFAULT_COLUMNS;
	}
		
	extract(shortcode_atts(Array(
		'key' => isset($options['elvanto_api_key']) ? $options['elvanto_api_key'] : false,
		'offset' => isset($options['offset']) ? $options['offset'] : 0,
		'weeks' => isset($options['elvanto_weeks']) ? $options['elvanto_weeks'] : 1,
		'in_plan' => isset($options['song_in_plan']) ? $options['song_in_plan'] : false,
		'video_width' => isset($options['song_video_width']) ? $options['song_video_width'] : 240,
		'video_height' => isset($options['song_video_height']) ? $options['song_video_height'] : 160,
		'services' => isset($options['elvanto_services']) ? $options['elvanto_services'] : 0,
		'service_types' => isset($options['roster_service_types']) ? $options['roster_service_types'] : false,
		'categories' => isset($options['songs_categories']) ? $options['songs_categories'] : 0,
		'columns' => $default_columns,
		'dates' => isset($options['elvanto_date_format']) && $options['elvanto_date_format'] ? 
						$options['elvanto_date_format'] : $system_date_format,
		'zone' => (isset($options['elvanto_time_zone']) && $options['elvanto_time_zone']) ? 
						$options['elvanto_time_zone'] : (get_option('timezone_string', false) ? 
													 get_option('timezone_string') :  
													 date_default_timezone_get()),
		'fullscreen' => false,
		'sort' => 'default'
	), $atts));

	$display_columns = explode(',',$columns);
	$content = '';
	foreach ($display_columns as $col) $content .= '<span class="elvantotools_song_'.$col.'">['.$col.']</span>';
	$prefix = '<div class="elvantotools_songs '.($fullscreen ? 'elvantotools_fullscreen' : '').'"><div class="elvantotools_table_scroll"><table>';
	$suffix = '</table></div></div>';
	$top_left_content = '<span class="dashicons dashicons-editor-expand elvantotools_go_fullscreen '.($fullscreen ? 'elvantotools_fullscreen_on' : '').'"></span>';
	$header_prefix = '<thead class="elvantotools_header">';
	$header_suffix = '</thead>';
	$header_element_prefix = '<th>';
	$header_element_suffix = '</th>';
	$header_content = '<strong>[service]</strong>';
	$body_prefix = '<tbody>';
	$body_suffix = '</tbody>';
	$label_prefix = '<td class="elvantotools_label"><strong>';
	$label_suffix = '</strong></td>';
	$label_content = '';
	$header_label_content = str_replace('td','th',$label_content);
	$row_prefix = '<tr>';
	$row_suffix = '</tr>';
	$element_prefix = '<td class="[class]">';
	$element_suffix = '</td>';
	$name_prefix = '<div class="elvantotools_song" name="[id]">';
	$name_suffix = '</div>';
	$name_separator = '';
	$empty_prefix = '<tr><td>';
	$empty_suffix = '</td></tr>';
	
	$output = elvantotools_songs_generate ($key, $offset, $weeks, $services, $service_types, $categories, $display_columns, $dates, $zone, $sort, $prefix, $suffix, $top_left_content, $header_label_content, $header_content, $header_prefix, $header_suffix, $header_element_prefix, $header_element_suffix, $body_prefix, $body_suffix, $row_prefix, $row_suffix, $label_content, $element_prefix, $element_suffix, $name_prefix, $name_suffix, $name_separator, $content, $empty_prefix, $empty_suffix,$video_width,$video_height,$in_plan);

	return do_shortcode($output);
//	return do_shortcode($output . "Sortorder=" . $rss->get_sortorder() . ",Maxterm=$max");
}

if (is_admin())
	$elvantotools_settings_page = new ElvantoToolsSettingsPage();
	
// Now we set that function up to execute when the content is diplayed
add_shortcode('elvanto_roster', 'elvantotools_roster_shortcode');
add_shortcode('elvanto_songs', 'elvantotools_songs_shortcode');

function elvantotools_filter($content) {
    $block = join("|",array("elvanto_roster","elvanto_songs"));
    $rep = preg_replace("/(<p>)?\[($block)(\s[^\]]+)?\](<\/p>|<br \/>)?/","[$2$3]",$content);
    $rep = preg_replace("/(<p>)?\[\/($block)](<\/p>|<br \/>)?/","[/$2]",$rep);
return $rep;
}
//add_filter("the_content", "elvantotools_filter");

function register_elvantotools_widget() {
    register_widget( 'ElvantoTools_Roster_Widget' );
    register_widget( 'ElvantoTools_Songs_Widget' );
}
add_action( 'widgets_init', 'register_elvantotools_widget' );

wp_register_style('elvantotoolsStylesheet', plugins_url('style.css', __FILE__) );

function elvantotools_plugin_scripts() {
    wp_enqueue_script( 'elvantotools', plugins_url('elvantotools.js', __FILE__), array( 'jquery' ), '1.0.0', true );
	wp_enqueue_style('dashicons');
	//wp_enqueue_style( 'elvantotoolsStylesheet', get_stylesheet_uri(), array( 'dashicons' ), '1.0' );
}
add_action( 'wp_enqueue_scripts', 'elvantotools_plugin_scripts' );

?>