<?php
/**
 * @package ElvantoTools
 * @author JagTech
 * @version 2.1
 */
/*
Plugin Name: ElvantoTools
Plugin URI: http://jagtech.biz
Description: Display rosters and song lists from Elvanto
Author: JagTech
Version: 2.1
Author URI: http://jagtech.biz
*/

/*  Copyright 2015  JagTech  (email : sales@jagtech.biz)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

include_once('settings.php');
include_once('widget.php');

function elvantotools_roster_shortcode ($atts, $content = null) {
	//define('WP_DEBUG', true);
	$options = get_option('elvantotools_options');
	$system_date_format = 'M j, Y'; //get_option('date_format', 'M j, Y');
	$default_columns = '';
	foreach (explode(',', ELVANTOTOOLS_ROSTER_FIELD_NAMES) as $field) {
		if (isset($options['roster_'.$field]) && $options['roster_'.$field] == 'on') {
			if ($default_columns != '') {
				$default_columns .= ',';
			}
			$default_columns .= $field;
		}
	}
	if ($default_columns == '') {
		$default_columns = ELVANTOTOOLS_ROSTER_DEFAULT_COLUMNS;
	}
		
	extract(shortcode_atts(Array(
		'key' => isset($options['elvanto_api_key']) ? $options['elvanto_api_key'] : false,
		'offset' => isset($options['offset']) ? $options['offset'] : 0,
		'weeks' => isset($options['elvanto_weeks']) ? $options['elvanto_weeks'] : 1,
		'services' => isset($options['elvanto_services']) ? $options['elvanto_services'] : 0,
		'service_types' => isset($options['roster_service_types']) ? $options['roster_service_types'] : false,
		'departments' => isset($options['roster_departments']) ? $options['roster_departments'] : false,
		'show_details' => isset($options['roster_show_details']) ? $options['roster_show_details'] : false,
		'sub_departments' => isset($options['roster_sub_departments']) ? $options['roster_sub_departments'] : false,
		'positions' => isset($options['roster_positions']) ? $options['roster_positions'] : false,
		'merge' => isset($options['roster_positions_merge']) ? $options['roster_positions_merge'] : false,
		'show_depts' => isset($options['roster_show_depts']) ? ($options['roster_show_depts'] == 'on') : false,
		'show_subs' => isset($options['roster_show_subs']) ? ($options['roster_show_subs'] == 'on') : false,
		'columns' => $default_columns,
		'dates' => isset($options['elvanto_date_format']) && $options['elvanto_date_format'] ? 
						$options['elvanto_date_format'] : $system_date_format,
		'zone' => (isset($options['elvanto_time_zone']) && $options['elvanto_time_zone']) ? 
						$options['elvanto_time_zone'] : (get_option('timezone_string', false) ? 
													 get_option('timezone_string') :  
													 date_default_timezone_get()),
		'fullscreen' => false,
		'sort' => 'default'
	), $atts));

	$display_columns = explode(',',$columns);
	$content = '['.implode('] [',$display_columns).']';
	$prefix = '<div class="elvantotools_roster '.($fullscreen ? 'elvantotools_fullscreen' : '').'"><div class="elvantotools_table_scroll"><table>';
	$suffix = '</table></div></div>';
	$top_left_content = '<span class="dashicons dashicons-editor-expand elvantotools_go_fullscreen '.($fullscreen ? 'elvantotools_fullscreen_on' : '').'"></span>';
	$header_prefix = '<thead class="elvantotools_header">';
	$header_suffix = '</thead>';
	$header_element_prefix = '<th class="elvantotools-header-service">';
	$header_element_suffix = '</th>';
	$header_content = '[service]';
	$body_prefix = '<tbody>';
	$body_suffix = '</tbody>';
	$label_prefix = '<td class="elvantotools_label"><strong>';
	$label_suffix = '</strong></td>';
	$label_content = '';
	if ($show_depts) $label_content .= $label_prefix . '[department]' . $label_suffix;
	if ($show_subs) $label_content .= $label_prefix . '[sub_department]' . $label_suffix;
	$label_content .= $label_prefix . '[position]' . $label_suffix;
	$header_label_content = str_replace('td','th',$label_content);
	$row_prefix = '<tr>';
	$row_suffix = '</tr>';
	$element_prefix = '<td class="[class]">';
	$element_suffix = '</td>';
	$name_prefix = '<span class="elvantotools_name" name="[id]">';
	$name_suffix = '</span>';
	$name_separator = '<br>';
	$empty_prefix = '<tr><td>';
	$empty_suffix = '</td></tr>';
	
	$output = elvantotools_roster_generate ($key, $offset, $weeks, $services, $service_types, $departments, $sub_departments, $positions, $merge, $display_columns, $dates, $zone, $sort, $prefix, $suffix, $top_left_content, $header_label_content, $header_content, $header_prefix, $header_suffix, $header_element_prefix, $header_element_suffix, $body_prefix, $body_suffix, $row_prefix, $row_suffix, $label_content, $element_prefix, $element_suffix, $name_prefix, $name_suffix, $name_separator, $content, $empty_prefix, $empty_suffix, $show_details);

	return do_shortcode($output);
//	return do_shortcode($output . "Sortorder=" . $rss->get_sortorder() . ",Maxterm=$max");
}

function elvantotools_songs_shortcode ($atts, $content = null) {
	//define('WP_DEBUG', true);
	$options = get_option('elvantotools_options');
	$system_date_format = 'M j, Y'; //get_option('date_format', 'M j, Y');
	$default_columns = '';
	foreach (explode(',', ELVANTOTOOLS_SONG_FIELD_NAMES) as $field) {
		if (isset($options['songs_'.$field]) && $options['songs_'.$field] == 'on') {
			if ($default_columns != '') {
				$default_columns .= ',';
			}
			$default_columns .= $field;
		}
	}
	if ($default_columns == '') {
		$default_columns = ELVANTOTOOLS_SONGS_DEFAULT_COLUMNS;
	}
		
	extract(shortcode_atts(Array(
		'key' => isset($options['elvanto_api_key']) ? $options['elvanto_api_key'] : false,
		'offset' => isset($options['offset']) ? $options['offset'] : 0,
		'weeks' => isset($options['elvanto_weeks']) ? $options['elvanto_weeks'] : 1,
		'in_plan' => isset($options['song_in_plan']) ? $options['song_in_plan'] : false,
		'video_width' => isset($options['song_video_width']) ? $options['song_video_width'] : 240,
		'video_height' => isset($options['song_video_height']) ? $options['song_video_height'] : 160,
		'services' => isset($options['elvanto_services']) ? $options['elvanto_services'] : 0,
		'service_types' => isset($options['roster_service_types']) ? $options['roster_service_types'] : false,
		'categories' => isset($options['songs_categories']) ? $options['songs_categories'] : 0,
		'columns' => $default_columns,
		'dates' => isset($options['elvanto_date_format']) && $options['elvanto_date_format'] ? 
						$options['elvanto_date_format'] : $system_date_format,
		'zone' => (isset($options['elvanto_time_zone']) && $options['elvanto_time_zone']) ? 
						$options['elvanto_time_zone'] : (get_option('timezone_string', false) ? 
													 get_option('timezone_string') :  
													 date_default_timezone_get()),
		'fullscreen' => false,
		'sort' => 'default'
	), $atts));

	$display_columns = explode(',',$columns);
	$content = '';
	foreach ($display_columns as $col) $content .= '<span class="elvantotools_song_'.$col.'">['.$col.']</span>';
	$prefix = '<div class="elvantotools_songs '.($fullscreen ? 'elvantotools_fullscreen' : '').'"><div class="elvantotools_table_scroll"><table>';
	$suffix = '</table></div></div>';
	$top_left_content = '<span class="dashicons dashicons-editor-expand elvantotools_go_fullscreen '.($fullscreen ? 'elvantotools_fullscreen_on' : '').'"></span>';
	$header_prefix = '<thead class="elvantotools_header">';
	$header_suffix = '</thead>';
	$header_element_prefix = '<th>';
	$header_element_suffix = '</th>';
	$header_content = '<strong>[service]</strong>';
	$body_prefix = '<tbody>';
	$body_suffix = '</tbody>';
	$label_prefix = '<td class="elvantotools_label"><strong>';
	$label_suffix = '</strong></td>';
	$label_content = '';
	$header_label_content = str_replace('td','th',$label_content);
	$row_prefix = '<tr>';
	$row_suffix = '</tr>';
	$element_prefix = '<td class="[class]">';
	$element_suffix = '</td>';
	$name_prefix = '<div class="elvantotools_song" name="[id]">';
	$name_suffix = '</div>';
	$name_separator = '';
	$empty_prefix = '<tr><td>';
	$empty_suffix = '</td></tr>';
	
	$output = elvantotools_songs_generate ($key, $offset, $weeks, $services, $service_types, $categories, $display_columns, $dates, $zone, $sort, $prefix, $suffix, $top_left_content, $header_label_content, $header_content, $header_prefix, $header_suffix, $header_element_prefix, $header_element_suffix, $body_prefix, $body_suffix, $row_prefix, $row_suffix, $label_content, $element_prefix, $element_suffix, $name_prefix, $name_suffix, $name_separator, $content, $empty_prefix, $empty_suffix,$video_width,$video_height,$in_plan);

	return do_shortcode($output);
//	return do_shortcode($output . "Sortorder=" . $rss->get_sortorder() . ",Maxterm=$max");
}

function elvantotools_map_shortcode ($atts, $content = null) {
	//define('WP_DEBUG', true);
	$options = get_option('elvantotools_options');
	$system_date_format = 'M j, Y'; //get_option('date_format', 'M j, Y');
	$default_columns = '';
		
	extract(shortcode_atts(Array(
		'key' => isset($options['elvanto_api_key']) ? $options['elvanto_api_key'] : false,
		'map_key' => isset($options['map_api_key']) ? $options['map_api_key'] : false,
		'geo_key' => isset($options['geocoding_api_key']) ? $options['geocoding_api_key'] : false,		
		'default_location' => isset($options['map_default_location']) ? $options['map_default_location'] : false,
		'map_email' => isset($options['map_contact_email']) ? $options['map_contact_email'] : false,
		'group_leaders' => isset($options['map_email_leaders']) ? $options['map_email_leaders'] : false,		
		'groups_table' => isset($options['map_groups_table']) ? $options['map_groups_table'] : false,		
		'approximate' => isset($options['map_approximate_locations']) ? $options['map_approximate_locations'] : false,		
		'group_category' => isset($options['elvanto_group_category']) ? $options['elvanto_group_category'] : false,
		'contact_fields' => isset($options['map_contact_fields']) ? $options['map_contact_fields'] : 'name,email',
		'dates' => isset($options['elvanto_date_format']) && $options['elvanto_date_format'] ? 
						$options['elvanto_date_format'] : $system_date_format,
		'zone' => (isset($options['elvanto_time_zone']) && $options['elvanto_time_zone']) ? 
						$options['elvanto_time_zone'] : (get_option('timezone_string', false) ? 
													 get_option('timezone_string') :  
													 date_default_timezone_get())
	), $atts));

	if (trim($group_category) == '') {
		$output = '<div class="elvantotools elvantotools_map elvantotools_map_error">Please select one or more group categories on the settings page</div>';
		return do_shortcode($output);
	}
	
	$group_categories = explode(',', $group_category);
	
	$contact_fields = explode(',', $contact_fields);
		
	$output = '';
	
	// Retrieve address cache
	$file = plugin_dir_path( __FILE__ ) . '/geo.txt';
	$geo = array();
	if (file_exists($file)) {
		$open = fopen($file, 'r');
		while (($line = fgetcsv($open)) !== FALSE) {
			if ($line[0])
		  		$geo[$line[0]] = array('lat'=>$line[1],'lng'=>$line[2]);
		}
		fclose($open);
	}
	
	// Set up the Elvanto request
	$fields = array(
		'suspended' => 'no',
		'fields[0]' => urlencode('categories'),
		'fields[1]' => urlencode('people')
	);
	
	if (count($group_categories) > 1) {
		for ($c = 0; $c < count($group_categories); $c++) {
			$fields['category_id['.$c.']'] = urlencode($group_categories[$c]);
		}
	} else {
		$fields['category_id'] = urlencode($group_category);
	}
	
	// Retrieve the Elvanto data or the cached result of a recent identical request
	global $elvantotools_last_error;
	if (($edata = elvantotools_curl_cache("https://api.elvanto.com/v1/groups/getAll.json", $fields, $key)) === FALSE) {
		$output = '<p>'.$elvantotools_last_error.'</p>';
		return $output;		
	}
	
	$jdata = json_decode($edata, true);	
	$groups = array();
	$group_ids = array();
	$emails = array();
	$url_geocode = "https://maps.googleapis.com/maps/api/geocode/json?address=%address%&key={$geo_key}";
	$open = fopen($file, 'a');
	
	$day_list = array();
	$freq_list = array();
	$time_list = array();
	
	$master_cats = array();
	
	foreach ($jdata['groups']['group'] as $group) {
		
		// There is an API bug that duplicates groups belonging to more than one of the group categories
		if (in_array($group['id'], $group_ids))
			continue;
		else
			$group_ids[] = $group['id'];
		
		//if ($group['name'] == 'Test BS')
			//error_log(print_r($group,true));
		$location = '';
		if ($group['meeting_address'])
			$location = $group['meeting_address'];
		if ($group['meeting_city']) {
			if ($location)
				$location .= ', ';
			$location .= $group['meeting_city'];
		}
		if ($location) {
			if ($group['meeting_postcode'])
				$location .= ', ' . $group['meeting_postcode'];
			if ($group['meeting_country'])
				$location .= ', ' . $group['meeting_country'];
			elseif ($default_location)
				$location .= ', ' . $default_location;
			
			$loclwr = strtolower($location);
			if (!isset($geo[$loclwr])) {
				if ($resp = file_get_contents(str_replace('%address%', urlencode($location), $url_geocode))) {
					$resp = json_decode($resp, true);
					if ($resp['status'] == 'OK') {
						if (isset($resp['results'][0]['geometry']['location']['lat']) && isset($resp['results'][0]['geometry']['location']['lng'])) {
							$coded = array('lat'=>$resp['results'][0]['geometry']['location']['lat'], 'lng'=>$resp['results'][0]['geometry']['location']['lng']);
							fwrite($open, '"' . $loclwr . '",' . $coded['lat'] . ',' . $coded['lng'] . "\n");
							$geo[$loclwr] = $coded;
						}
					}
				}
			} 
			
			if (isset($geo[$loclwr])) {
				$loc = $geo[$loclwr];
				$meeting_time = strtolower(str_replace(' ','',$group['meeting_time']));
				$grp_data = array('id'=>$group['id'],
								  'lat'=>$approximate ? floatval($loc['lat']) + (rand(-9,9) / 10000) : $loc['lat'],
								  'lng'=>$approximate ? floatval($loc['lng']) + (rand(-9,9) / 10000) : $loc['lng'],
								  'name'=>$group['name'], 
								  'city'=>$group['meeting_city'],
								  'desc'=>trim(str_replace(array("\r","\n"),'',$group['description'])),
								  'logo'=>$group['picture'],
								  'day'=>$group['meeting_day'],
								  'time'=>$meeting_time,
								  'freq'=>$group['meeting_frequency']);
				
				if (!isset($day_list[$group['meeting_day']]))
					$day_list[$group['meeting_day']] = $group['meeting_day'];
				if (!isset($time_list[$meeting_time]))
					$time_list[$meeting_time] = $meeting_time;
				if (!isset($freq_list[$group['meeting_frequency']]))
					$freq_list[$group['meeting_frequency']] = $group['meeting_frequency'];
				
				$grp_data['lead'] = '';
				if (isset($group['people']) && isset($group['people']['person'])) {
					$grp_data['ppl'] = 0;
					foreach ($group['people']['person'] as $person) {
						$grp_data['ppl']++;
						if ($person['position']) {
							if (isset($emails[$group['id']])) {
								$emails[$group['id']].=','.$person['email'];
								$grp_data['lead'] .= ', '.$person['firstname'];							
							} else {
								$emails[$group['id']]=$person['email'];						
								$grp_data['lead'] = $person['firstname'];							
							}
						}
					}
				}				
				
				$grp_data['cats'] = array();
				if (isset($group['categories']['category'])) {
					foreach ($group['categories']['category'] as $category) {
						if (in_array($category['id'], $group_categories)) {
							if (!in_array($category['name'], $grp_data['cats']))
								$grp_data['cats'][] = $category['name'];
							if (!in_array($category['name'], $master_cats))
								$master_cats[] = $category['name'];
						}
					}
				}
				
				$groups[] = $grp_data;
			}
		}
	}
	
	fclose($open);
	
	//error_log(print_r($groups,true));
	
	// Create map and iterate cached group addresses for those in the category with a link to request membership
	$old_tz = date_default_timezone_get();
	date_default_timezone_set($zone);
	$last_interested = '';
	
	//error_log(print_r($_POST, true));
	if (isset($_POST) && isset($_POST['group_id']) && isset($_POST['email'])) {
		foreach ($groups as $group) {			
			if ($group['id'] == $_POST['group_id']) {
				$contacts = $map_email;
				if ($group_leaders && isset($emails[$group['id']])) {
					if ($contacts)
						$contacts.=',';
					$contacts.=$emails[$group['id']];
				}
				if ($contacts) {
					if (!isset($_POST['last']) || $group['id'] != $_POST['last']) {
						if (wp_mail($contacts, 'Elvanto group - expression of interest', 'You have received an expression of interest in the "' . $group['name'] . '" group from' . (isset($_POST['person_name']) ? ' name: ' . $_POST['person_name'] : '') . (isset($_POST['email']) ? ' email: ' . $_POST['email'] : '') . (isset($_POST['phone']) ? ' phone number: ' . $_POST['phone'] : ''). (isset($_POST['address']) ? ' address: ' . $_POST['address'] : '') . ' via the group map on your website ('.($_SERVER['HTTPS'] ? 'https://' : 'http://').$_SERVER['HTTP_HOST'] .$_SERVER['REQUEST_URI'].').')) {
							$output .= '<div class="elvantotools elvantotools_map elvantotools_map_notify">We have sent an email to the group leaders and they will be in contact shortly!</div>';
							$last_interested = $group['id'];
						} else {
							$output .= '<div class="elvantotools elvantotools_map elvantotools_map_error">Sorry, we failed to send an email to the group leaders - please contact us directly</div>';
						}
					}
				} else {
					$output .= '<div class="elvantotools elvantotools_map elvantotools_map_error">Sorry, we failed to find any contact details for this group - please contact us directly</div>';
				}
				break;
			}
		}
	}
	
	// Create the search fields
	$day_options = '<option value="">Any</option>';
	foreach ($day_list as $key=>$val)
		$day_options .= '<option value="'.$val.'">'.$val.'</option>';
	$time_options = '<option value="">Any</option>';
	foreach ($time_list as $key=>$val)
		$time_options .= '<option value="'.$val.'">'.$val.'</option>';
	$freq_options = '<option value="">Any</option>';
	foreach ($freq_list as $key=>$val)
		$freq_options .= '<option value="'.strtolower($val).'">'.$val.'</option>';
	$cat_options = '<option value="">Any</option>';
	foreach ($master_cats as $val)
		$cat_options .= '<option value="'.$val.'">'.$val.'</option>';
	
	$output .= '<table class="elvantotools_map_search"><thead><tr><th>Day</th><th>Time</th><th>Frequency</th><th '.(count($group_categories) > 1 ? '' : 'style="display:none"').'>Category</th><th id="group_dist_header" style="display:none">Minutes</th><th>Description</th></tr></thead>
				<tbody><tr> <td><select id="group_day" onchange="filtergroups();">'.$day_options.'</select></td>
							<td><select id="group_time" onchange="filtergroups();">'.$time_options.'</select></td>
							<td><select id="group_freq" onchange="filtergroups();">'.$freq_options.'</select></td>
							<td '.(count($group_categories) > 1 ? '' : 'style="display:none"').'><select id="group_cats" onchange="filtergroups();">'.$cat_options.'</select></td>
							<td id="group_dist_parent" style="display:none"><input type="number" min="0" id="group_dist" onchange="filtergroups();" value="0"></td>			
							<td><input type="text" id="group_desc" onkeyup="filtergroups();"></td></tr></tbody></table>';
	
	$output .= '<div id="gmap_canvas" style="width:100%; height:400px"><img src="https://upcast.me/egm/page-loader.gif" style="width:32px; height:32px;"></div>';
	
	if ($groups_table) {
		$output .= '<table id="group_table" class="elvantotools_map_table"><tbody>';
		foreach ($groups as $group) {
			$output .= '<tr id="row-'.$group['id'].'"><td><img src="'.$group['logo'].'"></td><td><h1><a onclick="gotogroup(this)">'.$group['name'].'</a></h1><p>'.($group['day']?$group['day'].' ':'').($group['time']?'at '.$group['time'].' ':'').strtolower($group['freq']).' in '.$group['city'].'<span id="dur-'.$group['id'].'"></span>. '.(isset($group['ppl'])?$group['ppl'].' people ':'&nbsp;').($group['lead']?'lead by <strong>'.$group['lead'].'</strong>':'').'</p></p></td><td>'.$group['desc'].'</td></tr>';
		}
		$output .= '</tbody></table>';
	}
	
	$output .= '<script type="text/javascript">
	        var map;
			var index;
			var markers = [];
			var positions = [];
			var userMarker;
			var userPos;
			var matrixService;
			var directionsService;
			var directionsDisplay;
			var bounds;
			var groups = '.json_encode($groups).';
			function init_map() {
				if (!groups.length)
					document.getElementById("gmap_canvas").innerHTML = "<div class=\"elvantotools elvantotools_map elvantotools_map_error\">Sorry, we failed to find any groups to display - please contact us directly</div>";
			    bounds = new google.maps.LatLngBounds();
				for (var g in groups) {
					var group = groups[g];
					var pos = new google.maps.LatLng(group.lat, group.lng);
					positions.push(pos);
					if (g == 0)
						map = new google.maps.Map(document.getElementById("gmap_canvas"), {zoom: 5, mapTypeControl:false, center: pos, mapTypeId: google.maps.MapTypeId.ROADMAP});
					var marker = new google.maps.Marker({map: map, position: pos, clickable: true, group: g});
					marker.pos = pos;
					markers.push(marker);
					bounds.extend(pos);
					marker.info = new google.maps.InfoWindow({content: "<div class=\"elvantotools elvantotools_map\"><h1>"+group.name+"</h1>' . 
								 '<table><tbody><tr><td><img src=\""+group.logo+"\"></td><td>"+group.desc+"' .
								 '<p>"+(group.day?group.day+" ":"")+(group.time?"at "+group.time+" ":"")+group.freq.toLowerCase()+" in <strong>"+group.city+"</strong> <span></span></p>' .
								 '<p>"+(group.ppl?group.ppl+" people":"")+"' .
								 '"+(group.lead?" lead by <strong>"+group.lead+"</strong></p>":"")+"</p></td></tr></tbody></table>' .
					'<form method=\"post\" name=\"form-"+group.id+"\" class=\"elvantotools elvantotools_map\"><div class=\"elvantotools_map_interested\"><div>'.(in_array('name', $contact_fields) ? '<input name=\"person_name\" type=\"text\" placeholder=\"Your name\" required>' : '').(in_array('email', $contact_fields) ? '<input name=\"email\" type=\"email\" placeholder=\"Your email\" required>' : '').(in_array('phone', $contact_fields) ? '<input name=\"phone\" type=\"tel\" placeholder=\"Your number\" required>' : '').(in_array('address', $contact_fields) ? '<input name=\"address\" type=\"text\" placeholder=\"Your address\" required>' : '').'</div><input name=\"group_request\" type=\"submit\" value=\"Interested\"><input type=\"hidden\" name=\"group_id\" value=\""+group.id+"\"><input type=\"hidden\" name=\"last\" value=\"'.$last_interested.'\"></div></form></div>"});
					;
					google.maps.event.addListener(marker, "click", function () {
						var closed = !this.info.getMap(); 
						markers.forEach(function (e) {e.info.close();});';
	
		// It's confusing and misleading to show directions if the locations are approximate
	  if (!$approximate)
		$output .= '    if (closed && userMarker != null) {
							if ("route" in this) {
								directionsDisplay.setMap(map);
								directionsDisplay.setDirections(this.route);
							} else {
								userMarker.dest = this;
								directionsService.route({origin: userPos, destination: this.pos, travelMode: "DRIVING"},
														function (result, status) {
															userMarker.dest.route = result;
															directionsDisplay.setMap(map);
															directionsDisplay.setDirections(result);
															userMarker.dest.info.open(map, userMarker.dest);
														});
							}
						}';
	
		$output .= '    if (closed) {
							if (userMarker == null || "route" in this || !("dest" in userMarker))
								this.info.open(map, this);
						} else {
							this.info.close();
							directionsDisplay.setMap(null);
						}
					});
				}
				if (map) {
	           		map.fitBounds(bounds);
					if ("geolocation" in navigator) {
				  		navigator.geolocation.getCurrentPosition(function(position) {
							userPos = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
							bounds.extend(userPos);
							map.fitBounds(bounds);
							userMarker = new google.maps.Marker({map: map, position: userPos, clickable:false, animation: google.maps.Animation.DROP, label: "You"});
							matrixService = new google.maps.DistanceMatrixService();
							directionsService = new google.maps.DirectionsService();
							directionsDisplay = new google.maps.DirectionsRenderer({suppressMarkers:true, suppressInfoWindows:true});
							for (var block = 0; block < Math.ceil(positions.length / 25); block++) {
								setTimeout(function (b) {				
									var slice = positions.slice(b*25, b*25 + Math.min(positions.length - b*25, 25) - 1);
									matrixService.getDistanceMatrix(
										{origins: [userPos], destinations: slice, travelMode: "DRIVING", unitSystem: google.maps.UnitSystem.METRIC}, 
										function(resp, status) {
											if (status == "OK") {													
												  document.getElementById("group_dist_header").style.display = "";
												  document.getElementById("group_dist_parent").style.display = "";
												  var results = resp.rows[0].elements;
												  var dests = resp.destinationAddresses;
												  for (var j = 0; j < results.length; j++) {
													var element = results[j];
													if (element.status == "OK") {
														var group = groups[b*25 + j];
														var marker = markers[b*25 + j];
														if ("distance" in element) {
															group.dist = element.distance.value/1000;
														}
														if ("duration" in element) {
															group.dur = element.duration.value/60;
															marker.info.setContent(marker.info.content.replace("<span></span>", "(" + element.duration.text + " away)"));
															document.getElementById("dur-"+group.id).innerHTML = " (" + element.duration.text + " away)";
														}
													}
												  }										
											} else {
												console.log("getDistanceMatrix returned status "+status);
											}
										});
								}, (block && !(block % 4)) ? 1000 : 0, block);
							}
						}, function(err) {console.warn(`ERROR(${err.code}): ${err.message}`);}, {enableHighAccuracy: true});
					}
				}
            }
			function filtergroups() {
				var groupDay = document.getElementById("group_day").options[document.getElementById("group_day").selectedIndex].value;
				var groupTime = document.getElementById("group_time").options[document.getElementById("group_time").selectedIndex].value;
				var groupFreq = document.getElementById("group_freq").options[document.getElementById("group_freq").selectedIndex].value;
				var groupCat = document.getElementById("group_cats").options[document.getElementById("group_cats").selectedIndex].value;
				var groupDist = document.getElementById("group_dist").value;
				var groupDesc = document.getElementById("group_desc").value.toLowerCase();
				var groupTable = document.getElementById("group_table");
				markers.forEach(function (m) {
					var show = ((groupDay == "" || groups[m.group].day == groupDay ) &&
							  (groupTime == "" || groups[m.group].time == groupTime ) &&
							  (groupFreq == "" || groups[m.group].freq.toLowerCase() == groupFreq ) &&
							  (groupCat == "" || groups[m.group].cats.indexOf(groupCat) != -1) &&
							  (groupDist == "0" || groupDist == "" || ("dur" in groups[m.group] && Math.round(groups[m.group].dur) <= groupDist)) &&
							  (groupDesc == "" || groups[m.group].desc.toLowerCase().indexOf(groupDesc) != -1));
					m.setMap(show ? map : null);
					if (groupTable)
						document.getElementById("row-"+groups[m.group].id).style.display = (show ? "" : "none");
				});
			}
			function gotogroup(t) {
				markers.forEach(function (m) {
					if ("row-"+groups[m.group].id == t.parentElement.parentElement.parentElement.id) {
						document.getElementById("gmap_canvas").scrollIntoView(true);
						map.setCenter(m.getPosition());
						if (!m.info.getMap()) {
							google.maps.event.trigger(m, "click", {
							  latLng: m.pos
							});						
						}
					}
				});
			}
			</script>
			';
	$output .= '<script async defer type="text/javascript" src="https://maps.google.com/maps/api/js?key=' . $map_key. '&callback=init_map"></script>';
	
	date_default_timezone_set($old_tz);
	
	return do_shortcode($output);
//	return do_shortcode($output . "Sortorder=" . $rss->get_sortorder() . ",Maxterm=$max");
}

if (is_admin())
	$elvantotools_settings_page = new ElvantoToolsSettingsPage();
	
// Now we set that function up to execute when the content is diplayed
add_shortcode('elvanto_roster', 'elvantotools_roster_shortcode');
add_shortcode('elvanto_songs', 'elvantotools_songs_shortcode');
add_shortcode('elvanto_map', 'elvantotools_map_shortcode');

function elvantotools_filter($content) {
    $block = join("|",array("elvanto_roster","elvanto_songs","elvanto_map"));
    $rep = preg_replace("/(<p>)?\[($block)(\s[^\]]+)?\](<\/p>|<br \/>)?/","[$2$3]",$content);
    $rep = preg_replace("/(<p>)?\[\/($block)](<\/p>|<br \/>)?/","[/$2]",$rep);
return $rep;
}
//add_filter("the_content", "elvantotools_filter");

function register_elvantotools_widget() {
    register_widget( 'ElvantoTools_Roster_Widget' );
    register_widget( 'ElvantoTools_Songs_Widget' );
}
add_action( 'widgets_init', 'register_elvantotools_widget' );

wp_register_style('elvantotoolsStylesheet', plugins_url('style.css', __FILE__) );

function elvantotools_plugin_scripts() {
    wp_enqueue_script( 'elvantotools', plugins_url('elvantotools.js', __FILE__), array( 'jquery' ), '1.0.0', true );
	wp_enqueue_style('dashicons');
	//wp_enqueue_style( 'elvantotoolsStylesheet', get_stylesheet_uri(), array( 'dashicons' ), '1.0' );
}
add_action( 'wp_enqueue_scripts', 'elvantotools_plugin_scripts' );

?>